#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf samba-1.9.18p10.tar.gz
    cd samba-1.9.18p10
    bunzip2 -c ../samba-1.9.18p10-dietpc-patch.bz2 | patch -p1 -b
    cd source
    ed -s Makefile >/dev/null <<EOF
/^FLAGS1 =/d
i
FLAGS1 = $CFLAGS -DSYSLOG
.
w
q
EOF
    make
    strip -R .note -R .comment smbd nmbd smbpasswd
    mkdir -p ../../smbd/sbin ../../nmbd/sbin ../../smbpasswd/bin
    cp smbd ../../smbd/sbin/
    cp nmbd ../../nmbd/sbin/
    cp smbpasswd ../../smbpasswd/bin/
    cd ../..
    rm -rf samba-1.9.18p10
}

chmod 0600 smbd/etc/samba/smbpasswd

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
